/*
 448Delta.C - Main 448Delta Source File

int WINAPI WinMain(HINSTANCE hInst, HINSTANCE hPrevious, LPSTR Cmd , int CmdShow)

*/
					   /*---( Data Encryption Project )---*/
					  /*---( Started February 7, 1998 )---*/

#include <Windows.H>	   // Standard Windows Definitions & Functions
#include <WindowsX.H>	   // Standard Windows Definitions & Functions
#include <CommCTRL.H>	   // Standard Common Controls Definitions & Functions
#include <WinUser.H>	   // Standard USER Procedure Definitions & Functions
#include <IO.H> 		   // Standard I/O Definitions & Functions
#include <Stdio.H>		   // Standard STD I/O Definitions & Functions
#include <Stdlib.H> 	   // Standard STD Library Definitions & Functions
#include <String.H> 	   // Standard String Manipulation Definitions & Functions
#include <CType.H>		   // Standard Character Classification/Conversion Definitions & Functions
#include <ShellAPI.H>	   // Standard Shell.Dll Functions, Types, And Definitions

#include "Headers/Windows.H"		// 448Delta Definitions For Windows.Dll
#include "Headers/Registry.H"		// 448Delta Definitions For Registry.Dll
#include "Headers/BlowFish.H"		// 448Delta Definitions For BlowFish.Dll

#include "Headers/Definitions.H"	// 448Delta Misc. Definitions

#include "Headers/DeleteObject.H"	// 448Delta Delete A File Or Directory Structure

#include "Headers/LZARI.H"      	// 448Delta LZARI Compression Functions

#include "Headers/Functions.H"		// 448Delta Misc. Functions

#include "Headers/PackFiles.H"		// 448Delta Pack Files Functions
#include "Headers/UnpackFiles.H"	// 448Delta Unpack Files Functions

#include "Headers/Interface.H"		// 448Delta BlowFish Crypting Interface
#include "Headers/448Coding.H"		// 448Delta Encryption Algorithm Starter

#include "Dialogs/Password.H"		// 448Delta Password Dialog
#include "Dialogs/Confirm.H"		// 448Delta Confirm Password Dialog
#include "Dialogs/About.H"			// 448Delta About Dialog
#include "Dialogs/Status.H" 		// 448Delta Status Dialog

#include "Headers/Processes.H"		// 448Delta Crypting Processes Functions

////////////////////////////////////////////////////////////////////////

int WINAPI WinMain(HINSTANCE hInst, HINSTANCE hPrevious, LPSTR Cmd , int CmdShow)
{
	HANDLE xMutex;

	if( (xMutex = OpenMutex(SYNCHRONIZE, FALSE, "448Delta Priority")) )
	{
		MessageBox (NULL, "You Cannot Run 448Delta While You Are Changing The Priority." , TitleCaption, 0 + MB_ICONASTERISK + MB_SYSTEMMODAL);
		ReleaseMutex(xMutex);
		CloseHandle(xMutex);
		return 1;
	}

	if( (xMutex = OpenMutex(SYNCHRONIZE, FALSE, TitleCaption)) )
	{
		MessageBox (NULL, "Only One Instance Of 448Delta Can Run At A Time!" , TitleCaption, 0 + MB_ICONASTERISK + MB_SYSTEMMODAL);
		ReleaseMutex(xMutex);
		CloseHandle(xMutex);
		return 1;
	}
	xMutex = CreateMutex(0, 0, TitleCaption);

	hInstance = hInst;

	if(SetTempVariables()) Error("Main: Error Setting Temporary Files. Error 1.");

	if(strcmp(Cmd,"448DeltaSignature") == 0)
	{
		char xSignature[30];
		sprintf(xSignature,"%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c\n",65,117,116,104,101,110,116,105,99,32,52,52,56,68,101,108,116,97,32,83,105,103,110,97,116,117,114,101);
		MessageBox(0, xSignature ,DeltaVersion, 0 + MB_TASKMODAL);
		ReleaseMutex(xMutex);
		CloseHandle(xMutex);
		return 1;
	}

	if(CheckRegistered())
	{
		if(ProcessInput(Cmd)) // If No Input Diaplay About Box
		{
			DialogBox(hInstance,MAKEINTRESOURCE(1000),0,AboutDialog);
			return 0;
		}
	}

	ReleaseMutex(xMutex);
	CloseHandle(xMutex);

	return 0;
}

////////////////////////////////////////////////////////////////////////

