/*

 Definitions.H - Variable Definition File (Various & Assorted)

*/

//--------------------------------------------------------------------

#define TitleCaption "448Delta Encryption"
#define DeltaVersion "Version 3.5 - Revision B"

#define FlagLEN 8			// Length Of Encrypt/Pack Flags

#define PACCompress "448CPack"
#define ENCCompress "448CFile"

#define PACFlag "448Pack~"
#define ENCFlag "448File~"

#define BufferSize 512	  // Size Of Buffer Used For Copy Processes
#define MegaByte 1048576  // One Megabyte (1,048,576 Bytes)
#define RegCode 125874912 /* Number Written To Registry By Register
							  To Valadate Registration */

#define Reg_ShortVersion "3.5"
#define Reg_MaxFiles 25000
#define Reg_MaxPackFileSize 250
#define Reg_MaxFileSize 2500

#define Unreg_ShortVersion "UNREGISTERED"
#define Unreg_MaxFiles 10
#define Unreg_MaxPackFileSize 1
#define Unreg_MaxFileSize 5

//--------------------------------------------------------------------
		/* Thread Handles, ID's And Prototypes*/ // Begin

// --------

DWORD WINAPI EncryptProcess_Thread(LPVOID);
HANDLE EncryptProcess_Thread_Handle;
DWORD EncryptProcess_Thread_ID;

DWORD WINAPI DecryptProcess_Thread(LPVOID);
HANDLE DecryptProcess_Thread_Handle;
DWORD DecryptProcess_Thread_ID;

DWORD WINAPI PackProcess_Thread(LPVOID);
HANDLE PackProcess_Thread_Handle;
DWORD PackProcess_Thread_ID;

DWORD WINAPI UnpackProcess_Thread(LPVOID);
HANDLE UnpackProcess_Thread_Handle;
DWORD UnpackProcess_Thread_ID;

// --------

DWORD WINAPI CompressEncryptProcess_Thread(LPVOID);
HANDLE CompressEncryptProcess_Thread_Handle;
DWORD CompressEncryptProcess_Thread_ID;

DWORD WINAPI DecompressDecryptProcess_Thread(LPVOID);
HANDLE DecompressDecryptProcess_Thread_Handle;
DWORD DecompressDecryptProcess_Thread_ID;

DWORD WINAPI CompressPackProcess_Thread(LPVOID);
HANDLE CompressPackProcess_Thread_Handle;
DWORD CompressPackProcess_Thread_ID;

DWORD WINAPI DecompressUnpackProcess_Thread(LPVOID);
HANDLE DecompressUnpackProcess_Thread_Handle;
DWORD DecompressUnpackProcess_Thread_ID;

// --------

DWORD WINAPI StatusDialog_Thread(LPVOID );
HANDLE StatusDialog_Thread_Handle;
DWORD StatusDialog_Thread_ID;

		/* Thread Handles, ID's And Prototypes*/ // End
//--------------------------------------------------------------------
		/* Various Function Prototypes */ // Begin

void Error(char *);
void ClearBuffer(void);
void Update_LastUsed(void);
void FreeMemory(void);
void Clear_ReadTemp(void);

BOOL CALLBACK PasswordDialog  (HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK ConfirmDialog   (HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK AboutDialog	  (HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK StatusDialog	  (HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK CompatibleDialog(HWND, UINT, WPARAM, LPARAM);

int PackFiles(char *,char *);
int UnPackFiles(char *,char *);

int IncodeMain(char *, char *);
int DecodeMain(char *, char *);

int EncryptProcess(void);
int DecryptProcess(void);
int PackProcess(void);
int UnpackProcess(void);
int CompressEncryptProcess(void);
int DecompressDecryptProcess(void);
int CompressPackProcess(void);
int DecompressUnpackProcess(void);

int ProcessInput(char *);
int CancelProcess(void);

int Get_FileNames (char *);
int Get_SubFileNames (char *, char *);
int PackFolder(char *, char *);
int CleanUp(int, int);
int PreCheckFile(char *);
int SetTempVariables(void);
int CheckRegistered(void);

BOOL SetPriority(void);
BOOL CheckSerial();

LRESULT CALLBACK SetColor(int,int,int,int);

		/* Various Function Prototypes */ // End
//--------------------------------------------------------------------
		/* Various Global Variables */ // Begin

char Buffer[BufferSize];
char CompressTemp[257];
char PackTemp[257];
char Password[75];
char ReadTemp[1024];
char InputFileName[257];
char OutputFileName[257];

struct _Package{
char *FolderNames[Reg_MaxFiles+2];
char *FileNames[Reg_MaxFiles+2];
DWORD FileCount;
DWORD FolderCount;
}; struct _Package Package;

char *Status;
char *CodedKey;
char *ShortVersion;

DWORD MaxFiles		  = 0;
DWORD MaxPackFileSize = 0;
DWORD MaxFileSize	  = 0;

long double StatusValue = 0;

		/* Various Global Variables */ // End
//--------------------------------------------------------------------
		/* Various Windows Handles */ // Begin

HINSTANCE hInstance 		   = 0;

HWND PasswordDialog_hWnd   = 0;
HWND ConfirmDialog_hWnd    = 0;
HWND AboutDialog_hWnd	   = 0;
HWND StatusDialog_hWnd	   = 0;
HWND CompatibleDialog_hWnd = 0;

HWND StatusText_hWnd = 0;
HWND StatusBar_hWnd  = 0;

		/* Various Windows Handles */ // End
//--------------------------------------------------------------------
		/* Global Variables Used As Flags (BOOL) */ // Begin

BOOL CompressEncrypt   = FALSE;
BOOL DecompressDecrypt = FALSE;
BOOL CompressPack	   = FALSE;
BOOL DecompressUnpack  = FALSE;

BOOL Encrypt = FALSE;
BOOL Decrypt = FALSE;
BOOL Pack	 = FALSE;
BOOL Unpack  = FALSE;

BOOL Registered = FALSE;
BOOL DeleteSource = FALSE;
BOOL CancelFlag = FALSE;
BOOL Verifiy	= FALSE;
BOOL DoneFlag	= FALSE;
BOOL KillFlag	= FALSE;
BOOL UseFlags	= TRUE;

		/* Global Variables Used As Flags */ // End
//--------------------------------------------------------------------


