
/////////////////////////////////////////////////////////////////////

void SetText (HWND xDialog, char *xText)
{
	SendMessage(xDialog,(UINT)WM_SETTEXT,(WPARAM)0,(LPARAM)xText);
}

/////////////////////////////////////////////////////////////////////

char *GetText (HWND xDialog)
{
	char *ReturnTemp;
	int Length;
	ReturnTemp = (char *) calloc(257,1);
	Length = GetWindowTextLength(xDialog);
	GetWindowText(xDialog,ReturnTemp,Length+1);
	return ReturnTemp;
}

/////////////////////////////////////////////////////////////////////

void CenterWindow (HWND xDialog)
{
	RECT wRect;
	DWORD CordX;
	DWORD CordY;
	GetWindowRect(xDialog,&wRect);
	CordX = (GetSystemMetrics(SM_CXSCREEN) - (wRect.right-wRect.left)) / 2;
	CordY = (GetSystemMetrics(SM_CYSCREEN) - (wRect.bottom - wRect.top + GetSystemMetrics(SM_CYCAPTION))) / 2;
	SetWindowPos(xDialog,NULL,CordX,CordY,0,0,SWP_NOSIZE | SWP_NOZORDER);
}

/////////////////////////////////////////////////////////////////////

int Unpack(char *xInputName,char *xOutputName)
{
	char DecryptTemp[257];
	sprintf(DecryptTemp,"%s\\%s",GetTempDirectory(),"DecryptTemp.Upd");

	char StatusTemp[1024];
	sprintf(StatusTemp,"Decrypting %d KBytes",Get_FileSize(xInputName)/1024);
	SetText(StatusText_hWnd,StatusTemp);

	if(DecodeMain(xInputName,DecryptTemp))
	{
		if(UnPackFiles(DecryptTemp,xOutputName))
		{
			SetText(StatusText_hWnd,"Operation Complete.");
		}
	}

	SetText(OkCancelButton_hWnd,"Ok");
	DoneFlag = TRUE;
	if(CancelFlag == TRUE)
	{
		xDeleteObject(xOutputName);
		SetText(StatusText_hWnd,"Canceled.");
		EnableWindow(OkCancelButton_hWnd,TRUE);
	}

	return 0;
}

//////////////////////////////////////////////////////////////////////

int DecompressDecrypt(char *xInputName,char *xOutputName)
{
	char DecryptTemp[257];
	sprintf(DecryptTemp,"%s\\%s",GetTempDirectory(),"DecryptTemp.Upd");
	char CompressTemp[257];
	sprintf(CompressTemp,"%s\\%s",GetTempDirectory(),"CompressTemp.Upd");

	char StatusTemp[1024];
	sprintf(StatusTemp,"Decrypting %d KBytes",Get_FileSize(xInputName)/1024);
	SetText(StatusText_hWnd,StatusTemp);

	if(DecodeMain(xInputName,DecryptTemp))
	{
		if(LZARIDecompress(DecryptTemp,xOutputName))
		{
			SetText(StatusText_hWnd,"Operation Complete.");
		}
	}

	SetText(OkCancelButton_hWnd,"Ok");
	DoneFlag = TRUE;
	if(CancelFlag == TRUE)
	{
		xDeleteObject(xOutputName);
		SetText(StatusText_hWnd,"Canceled.");
		EnableWindow(OkCancelButton_hWnd,TRUE);
	}

	return 0;
}

//////////////////////////////////////////////////////////////////////

int DecompressUnpack(char *xInputName,char *xOutputName)
{
	char DecryptTemp[257];
	sprintf(DecryptTemp,"%s\\%s",GetTempDirectory(),"DecryptTemp.Upd");
	char CompressTemp[257];
	sprintf(CompressTemp,"%s\\%s",GetTempDirectory(),"CompressTemp.Upd");

	char StatusTemp[1024];
	sprintf(StatusTemp,"Decrypting %d KBytes",Get_FileSize(xInputName)/1024);
	SetText(StatusText_hWnd,StatusTemp);

	if(DecodeMain(xInputName,DecryptTemp))
	{
		if(LZARIDecompress(DecryptTemp,CompressTemp))
		{
			if(UnPackFiles(CompressTemp,xOutputName))
			{
				SetText(StatusText_hWnd,"Operation Complete.");
			}
		}
	}

	SetText(OkCancelButton_hWnd,"Ok");
	DoneFlag = TRUE;
	if(CancelFlag == TRUE)
	{
		xDeleteObject(xOutputName);
		SetText(StatusText_hWnd,"Canceled.");
		EnableWindow(OkCancelButton_hWnd,TRUE);
	}

	return 0;
}

//////////////////////////////////////////////////////////////////////

int DecryptFile(char *xInputName,char *xOutputName)
{
	char DecryptTemp[257];
	sprintf(DecryptTemp,"%s\\%s",GetTempDirectory(),"DecryptTemp.Upd");
	char CompressTemp[257];
	sprintf(CompressTemp,"%s\\%s",GetTempDirectory(),"CompressTemp.Upd");

	char StatusTemp[1024];
	sprintf(StatusTemp,"Decrypting %d KBytes",Get_FileSize(xInputName)/1024);
	SetText(StatusText_hWnd,StatusTemp);

	if(DecodeMain(xInputName,xOutputName))
	{
		SetText(StatusText_hWnd,"Operation Complete.");
	}

	SetText(OkCancelButton_hWnd,"Ok");
	DoneFlag = TRUE;
	if(CancelFlag == TRUE)
	{
		xDeleteObject(xOutputName);
		SetText(StatusText_hWnd,"Canceled.");
		EnableWindow(OkCancelButton_hWnd,TRUE);
	}

	return 0;
}

//////////////////////////////////////////////////////////////////////

DWORD WINAPI UnPack_Thread(LPVOID data)
{
	char CleanSource[257];
	char CompressTemp[257];
	char DecryptTemp[257];
	int FlagResult;

	sprintf(DecryptTemp,"%s\\%s",GetTempDirectory(),"DecryptTemp.Upd");
	sprintf(CleanSource,"%s\\%s",GetTempDirectory(),"CleanSource.Upd");
	sprintf(CompressTemp,"%s\\%s",GetTempDirectory(),"CompressTemp.Upd");

	char *TargetDestination = Package.TargetDir;

	if(FileAccess(TargetDestination,FExist))
	{
		if(MessageBox(MainDialog_hWnd, "Target File Already Exist. Overwrite?" , TitleCaption, 0 + MB_YESNO + MB_DEFBUTTON2 + MB_ICONQUESTION) == IDNO)
		{
			SetText(StatusText_hWnd,"Canceled.");
			SetText(OkCancelButton_hWnd,"Ok");
			DoneFlag = TRUE;
			return 0;
		}
	}

	FlagResult = PreCheckFile(SourceFileName);

	if(FlagResult == 1)
		DecryptFile(SourceFileName,TargetDestination);
	if(FlagResult == 2)
		Unpack(SourceFileName,TargetDestination);
	if(FlagResult == 3)
		DecompressDecrypt(SourceFileName,TargetDestination);
	if(FlagResult == 4)
		DecompressUnpack(SourceFileName,TargetDestination);
	if(FlagResult == 5)
		ReportError("Executable Is Corrupt.");

	SetText(OkCancelButton_hWnd,"Ok");
	DoneFlag = TRUE;
	if(CancelFlag == TRUE)
	{
		SetText(StatusText_hWnd,"Canceled.");
		EnableWindow(OkCancelButton_hWnd,TRUE);
	}

	unlink(DecryptTemp);
	unlink(CleanSource);
	unlink(CompressTemp);

	return 0;
}

/////////////////////////////////////////////////////////////////////

void ReportError(char *xError)
{
	MessageBox(MainDialog_hWnd, xError, TitleCaption, 0);
}

/////////////////////////////////////////////////////////////////////

void ClearBuffer(void)
{
	int LocalLoop;
	LocalLoop = 0;
	while(LocalLoop < sizeof(Package.Buffer))
	{
		Package.Buffer[LocalLoop] = '\0';
		LocalLoop++;
	}
}

//////////////////////////////////////////////////////////////////////

void FreeMemory(void)
{
	while(Package.FolderCount != -1)
	{
		free(Package.FolderNames[Package.FolderCount]);
		Package.FolderNames[Package.FolderCount] = NULL;
		Package.FolderCount--;
	}

	while(Package.FileCount != -1)
	{
		free(Package.FileNames[Package.FileCount]);
		Package.FileNames[Package.FileCount] = NULL;
		Package.FileCount--;
	}
}

///////////////////////////////////////////////////////////////////////

void Clear_ReadTemp(void)
{
	int LocalLoop = 0;

	while(LocalLoop < sizeof(Package.ReadTemp))
	{
		Package.ReadTemp[LocalLoop] = '\0';
		LocalLoop++;
	}
}

//////////////////////////////////////////////////////////////////////

char *GetTempDirectory(void)
{
	char *Name;
	Name = (char *) calloc(257,1);
	GetTempPath(256,Name);
	return Name;
}

//////////////////////////////////////////////////////////////////////

int PreCheckFile(char *FileToCheck)
{
	FILE * FileToCheck_File;
	char Buffer[9];

	/* Check For File Access */
	if(!FileAccess(FileToCheck,FExist)) // Check Exist
	{
		ReportError("PreCheckFile: File Does Not Exist. Error 14.");
		return 0;
	}

	if((FileToCheck_File = fopen(FileToCheck,"rb")) == NULL) // Check Read Access
	{
		ReportError("PreCheckFile: File Does Not Allow Read Access. Error 15.");
		return 0;
	}

	if(FileToCheck_File)fclose(FileToCheck_File);

	/* Open Source File */
	if((FileToCheck_File = fopen(FileToCheck,"rb")) == NULL)
	{
		ReportError("PreCheckFile: Could Not Open Source For Read. Error: 16.");
		return 0;
	}

	fseek(FileToCheck_File,ExecutableEnd,SEEK_SET); // Seek Past Executable

	int LocalLoop = 0;
	while(LocalLoop != 9)
	{
		Buffer[LocalLoop] = '\0';
		LocalLoop++;
	}

	/* Read File Flag ( If Any ) */
	fread(Buffer,sizeof(char),FlagLEN,FileToCheck_File);

	if(strcmp(Buffer,ENCFlag) == 0) // If File Encryted
	{
		if(FileToCheck_File)
			fclose(FileToCheck_File);
		return 1;
	}

	if(strcmp(Buffer,PACFlag) == 0) // If File Packed
	{
		if(FileToCheck_File)
			fclose(FileToCheck_File);
		return 2;
	}

	if(strcmp(Buffer,ENCCompress) == 0) // If File Compressed Encryted
	{
		if(FileToCheck_File)
			fclose(FileToCheck_File);
		return 3;
	}

	if(strcmp(Buffer,PACCompress) == 0) // If File Compressed Packed
	{
		if(FileToCheck_File)
			fclose(FileToCheck_File);
		return 4;
	}

	if(FileToCheck_File)
		fclose(FileToCheck_File);
	return 5; // If File Not Encrypted
}

//////////////////////////////////////////////////////////////////////

DWORD Get_FileSize(char *File2Size)
{
	HANDLE Source;
	DWORD size;
	Source = CreateFile(File2Size,GENERIC_READ,0,NULL,OPEN_EXISTING,0,NULL);
	size = GetFileSize(Source,NULL);
	if(size == HFILE_ERROR) return -1;
	CloseHandle(Source);
	return size;
}

//////////////////////////////////////////////////////////////////////

BOOL FileAccess(char *FileName, short Mode)
{
	if(access(FileName, Mode) == 0)
		return TRUE;
	return FALSE;
}

//////////////////////////////////////////////////////////////////////

BOOL IsDirectory(char *xRequest)
{
	int Attrib;
	Attrib = GetFileAttributes(xRequest);
	if(Attrib != 0xFFFFFFFF)
	{
		if(Attrib & FILE_ATTRIBUTE_DIRECTORY)
			return TRUE;
	}
	return FALSE;
}

//////////////////////////////////////////////////////////////////////

